03-04 创建和编辑AutoCAD实体四 编辑二维命名对象 9

11、Edit Hatches 编辑图案填充

You can edit both hatch boundaries and hatch patterns. If you edit the boundary of an associative hatch,the pattern is updated as long as the editing results in a valid boundary. Associative hatches are updated even if they're on layers that are turned off. You can modify hatch patterns or choose a new pattern for an existing hatch,but associativity can only be set when a hatch is created. You can check to see if a Hatch object is associative by using the Associative property.

我们可以编辑填充边界和填充图案。如果编辑关联填充的边界,且编辑后边界合法,填充图案就会随之更新。即便所在的图层处于关闭状态,关联填充也会更新。我们可以修改填充图案,或为其选择新的填充图案,但是其关联属性只在填充创建时才能设置。我们可以使用Associative属性检查Hatch对象是否为关联的。

You must re-evaluate a hatch using the EvaluateHatch method to see any edits to the hatch.

要想看到编辑后的效果,必须使用EvaluateHatch方法重新对所编辑的填充进行求值。

For more information about editing hatches,see “Modify Hatches and Solid-Filled Areas” in theAutoCAD User's Guide.

更多关于编辑填充的内容,见AutoCAD用户指南中的“修改图案填充和实体填充区域”。

11.1、Edit Hatch Boundaries编辑填充边界

You can append,insert,or remove loops from the boundaries of a Hatch object. Associative hatches are updated to match any changes made to their boundaries. Non-associative hatches are not updated.

我们可以从Hatch对象的边界中追加、插入及删除边界环。关联性填充会更新以适应边界变化,非关联性填充不更新。

To edit a hatch boundary,use one of the following methods:

下列方法用于编辑填充边界:

AppendLoop

Appends a loop to the hatch. You define the type of loop being appended with first parameter of the AppendLoop method and the constants defined by the HatchLoopTypes enum.

给填充追加一个边界环,所追加边界环的类型由AppendLoop方法的第一个参数和HatchLoopTypes枚举类型的常量定义。

GetLoopAt

Gets the loop at a given index of a hatch. 获取填充给定索引位置的边界环。

InsertLoopAt

Inserts a loop at a given index of a hatch. 在填充的给定索引位置插入一个边界环。

RemoveLoopAt

Deletes a loop at a given index of a hatch. 在填充的给定索引位置删除一个边界环。

To query a hatch boundary,use one of the following methods:

下列方法用于查询填充的边界:

LoopTypeAt

Gets the type of loop at a given index of a hatch. 获取填充给定索引位置边界环的类型。

NumberOfLoops

Gets the number of loops of a hatch. 获取填充的边界环的个数。

Append an inner loop to a hatch 给填充追加一个内部边界环

This example creates an associative hatch. It then creates a circle and appends the circle as an inner loop to the hatch.

本例创建一个关联图案填充,然后创建一个圆并追加该圆作为填充的内部边界环。

VB.NET

Imports Autodesk.AutoCAD.Runtime

Imports Autodesk.AutoCAD.ApplicationServices

Imports Autodesk.AutoCAD.DatabaseServices

Imports Autodesk.AutoCAD.Geometry

<CommandMethod("EditHatchAppendLoop")> _

Public Sub EditHatchAppendLoop()

'' Get the current document and database

Dim acDoc As Document = Application.DocumentManager.MdiActiveDocument

Dim acCurDb As Database = acDoc.Database

'' Start a transaction

Using acTrans As Transaction = acCurDb.TransactionManager.StartTransaction()

'' Open the Block table for read

Dim acBlkTbl As BlockTable

acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId,_

OpenMode.ForRead)

'' Open the Block table record Model space for write

Dim acBlkTblRec As BlockTableRecord

acBlkTblRec = acTrans.GetObject(acBlkTbl(BlockTableRecord.ModelSpace),_

OpenMode.ForWrite)

'' Create an arc object for the closed boundary to hatch

Dim acArc As Arc = New Arc(New Point3d(5,3,0),3.141592)

acBlkTblRec.AppendEntity(acArc)

acTrans.AddNewlyCreatedDBObject(acArc,True)

'' Create an line object for the closed boundary to hatch

Dim acLine As Line = New Line(acArc.StartPoint,acArc.EndPoint)

acBlkTblRec.AppendEntity(acLine)

acTrans.AddNewlyCreatedDBObject(acLine,True)

'' Adds the arc and line to an object id collection

Dim acObjIdColl As ObjectIdCollection = New ObjectIdCollection()

acObjIdColl.Add(acArc.ObjectId)

acObjIdColl.Add(acLine.ObjectId)

'' Create the hatch object and append it to the block table record

Dim acHatch As Hatch = New Hatch()

acBlkTblRec.AppendEntity(acHatch)

acTrans.AddNewlyCreatedDBObject(acHatch,True)

'' Set the properties of the hatch object

'' Associative must be set after the hatch object is appended to the

'' block table record and before AppendLoop

acHatch.SetHatchPattern(HatchPatternType.PreDefined,"ANSI31")

acHatch.Associative = True

acHatch.AppendLoop(HatchLoopTypes.Outermost,acObjIdColl)

'' Create a circle object for the inner boundary of the hatch

Dim acCirc As Circle = New Circle()

acCirc.Center = New Point3d(5,4.5,0)

acCirc.Radius = 1

acBlkTblRec.AppendEntity(acCirc)

acTrans.AddNewlyCreatedDBObject(acCirc,True)

'' Adds the circle to an object id collection

acObjIdColl.Clear()

acObjIdColl.Add(acCirc.ObjectId)

'' Append the circle as the inner loop of the hatch and evaluate it

acHatch.AppendLoop(HatchLoopTypes.Default,acObjIdColl)

acHatch.EvaluateHatch(True)

'' Save the new object to the database

acTrans.Commit()

End Using

End Sub

C#

using Autodesk.AutoCAD.Runtime;

using Autodesk.AutoCAD.ApplicationServices;

using Autodesk.AutoCAD.DatabaseServices;

using Autodesk.AutoCAD.Geometry;

[CommandMethod("EditHatchAppendLoop")]

public static void EditHatchAppendLoop()

{

// Get the current document and database获取当前文档和数据库

Document acDoc = Application.DocumentManager.MdiActiveDocument;

Database acCurDb = acDoc.Database;

// Start a transaction启动事务

using (Transaction acTrans = acCurDb.TransactionManager.StartTransaction())

{

// Open the Block table for read以读打开块表

BlockTable acBlkTbl;

acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId,

OpenMode.ForRead) as BlockTable;

// Open the Block table record Model space for write以写打开块表记录模型空间

BlockTableRecord acBlkTblRec;

acBlkTblRec = acTrans.GetObject(acBlkTbl[BlockTableRecord.ModelSpace],

OpenMode.ForWrite) as BlockTableRecord;

// Create an arc object for the closed boundary to hatch创建一个圆弧对象作为填充的闭合边界

Arc acArc = new Arc(new Point3d(5,3.141592);

acBlkTblRec.AppendEntity(acArc);

acTrans.AddNewlyCreatedDBObject(acArc,true);

// Create an line object for the closed boundary to hatch创建一个直线对象作为填充的闭合边界

Line acLine = new Line(acArc.StartPoint,acArc.EndPoint);

acBlkTblRec.AppendEntity(acLine);

acTrans.AddNewlyCreatedDBObject(acLine,true);

// Adds the arc and line to an object id collection将圆弧和直线添加到ObjectIdCollection

ObjectIdCollection acObjIdColl = new ObjectIdCollection();

acObjIdColl.Add(acArc.ObjectId);

acObjIdColl.Add(acLine.ObjectId);

// Create the hatch object and append it to the block table record创建Hatch对象

Hatch acHatch = new Hatch();

acBlkTblRec.AppendEntity(acHatch);

acTrans.AddNewlyCreatedDBObject(acHatch,true);

// Set the properties of the hatch object设置填充对象的属性

// Associative must be set after the hatch object is appended to the

// block table record and before AppendLoop关联属性必须在将填充对象添加到块表记录之后、执行AppendLoop之前设置

acHatch.SetHatchPattern(HatchPatternType.PreDefined,"ANSI31");

acHatch.Associative = true;

acHatch.AppendLoop(HatchLoopTypes.Outermost,acObjIdColl);

// Create a circle object for the inner boundary of the hatch创建一个圆对象作为填充的内部边界

Circle acCirc = new Circle();

acCirc.Center = new Point3d(5,0);

acCirc.Radius = 1;

acBlkTblRec.AppendEntity(acCirc);

acTrans.AddNewlyCreatedDBObject(acCirc,true);

// Adds the circle to an object id collection将圆添加到ObjectIdCollection

acObjIdColl.Clear();

acObjIdColl.Add(acCirc.ObjectId);

// Append the circle as the inner loop of the hatch and evaluate it追加圆为内部边界环并对填充对象取值

acHatch.AppendLoop(HatchLoopTypes.Default,acObjIdColl);

acHatch.EvaluateHatch(true);

// Save the new object to the database保存到数据库

acTrans.Commit();

}

}

VBA/ActiveX Code Reference

Sub EditHatchAppendLoop()

Dim hatchObj As AcadHatch

Dim patternName As String

Dim PatternType As Long

Dim bAssociativity As Boolean

' Define and create the hatch

patternName = "ANSI31"

PatternType = 0

bAssociativity = True

Set hatchObj = ThisDrawing.ModelSpace. _

AddHatch(PatternType,patternName,bAssociativity)

' Create the outer loop for the hatch.

Dim outerLoop(0 To 1) As AcadEntity

Dim center(0 To 2) As Double

Dim radius As Double

Dim startAngle As Double

Dim endAngle As Double

center(0) = 5: center(1) = 3: center(2) = 0

radius = 3

startAngle = 0

endAngle = 3.141592

Set outerLoop(0) = ThisDrawing.ModelSpace. _

AddArc(center,radius,startAngle,endAngle)

Set outerLoop(1) = ThisDrawing.ModelSpace. _

AddLine(outerLoop(0).startPoint,outerLoop(0).endPoint)

' Append the outer loop to the hatch object

hatchObj.AppendOuterLoop (outerLoop)

' Create a circle as the inner loop for the hatch.

Dim innerLoop(0) As AcadEntity

center(0) = 5: center(1) = 4.5: center(2) = 0

radius = 1

Set innerLoop(0) = ThisDrawing.ModelSpace. _

AddCircle(center,radius)

' Append the circle as an inner loop to the hatch

hatchObj.AppendInnerLoop (innerLoop)

' Evaluate and display the hatch

hatchObj.Evaluate

ThisDrawing.Regen True

End Sub

11.2、Edit Hatch Patterns编辑填充图案

You can change the angle or spacing of an existing hatch pattern or replace it with a solid-fill,gradient fill,or one of the predefined patterns that AutoCAD offers. The Pattern option in the Boundary Hatch dialog box displays a list of these patterns. To reduce file size,the hatch is defined in the drawing as a single graphic object.

我们可以修改现有填充图案的角度或间隔,或者用实体填充、渐变色填充以及AutoCAD提供的预定义填充图案来替换现有填充图案。边界填充对话框的图案选项显示了这些图案的列表。为减小文件大小,在图形中将填充图案定义为单独的图像对象。

Use the following properties and methods to edit the hatch patterns:

下列属性和方法用于编辑填充图案:

GradientAngle

Specifies the gradient angle of the hatch. 指定填充的渐变色角度

GradientName

Returns the gradient name of the hatch. 返回填充的渐变色名称

GradientShift

Specifies the gradient shift of the hatch. 指定填充的渐变插值

GradientType

Returns the gradient type of the hatch. 返回填充的渐变色类型

PatternAngle

Specifies the angle of the hatch pattern. 指定填充图案的角度

PatternDouble

Specifies if the user-defined hatch is double-hatched. 指定用户自定义填充是否为双填充?

PatternName

Returns the hatch pattern name of the hatch. (Use the SetHatchPattern method to set the hatch pattern name and type of the hatch.) 返回填充图案的名称(使用SetHatchPattern方法设置填充的名称和类型)

PatternScale

Specifies the hatch pattern scale. 指定填充比例

PatternSpace

Specifies the user-defined hatch pattern spacing. 指定用户自定义填充的间隔

PatternType

Returns the hatch pattern type of the hatch. (Use the SetHatchPattern method to set the hatch pattern name and type of the hatch.) 返回填充图案的类型(使用SetHatchPattern方法设置填充的名称和类型)

SetGradient

Sets the gradient type and name for the hatch. 设置渐变填充的名称和类型

SetHatchPattern

Sets the pattern type and name for the hatch. 设置填充的名称和类型

Change the pattern spacing of a hatch 修改填充图案的间距

This example creates a hatch. It then adds two to the current pattern spacing for the hatch.

本例创建一个图案填充,然后将该填充图案的间距加2。

VB.NET

Imports Autodesk.AutoCAD.Runtime

Imports Autodesk.AutoCAD.ApplicationServices

Imports Autodesk.AutoCAD.DatabaseServices

Imports Autodesk.AutoCAD.Geometry

<CommandMethod("EditHatchPatternScale")> _

Public Sub EditHatchPatternScale()

'' Get the current document and database

Dim acDoc As Document = Application.DocumentManager.MdiActiveDocument

Dim acCurDb As Database = acDoc.Database

'' Start a transaction

Using acTrans As Transaction = acCurDb.TransactionManager.StartTransaction()

'' Open the Block table for read

Dim acBlkTbl As BlockTable

acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId,_

OpenMode.ForWrite)

'' Create a circle object for the boundary of the hatch

Dim acCirc As Circle = New Circle()

acCirc.Center = New Point3d(5,0)

acCirc.Radius = 3

acBlkTblRec.AppendEntity(acCirc)

acTrans.AddNewlyCreatedDBObject(acCirc,True)

'' Adds the arc and line to an object id collection

Dim acObjIdColl As ObjectIdCollection = New ObjectIdCollection()

acObjIdColl.Add(acCirc.ObjectId)

'' Create the hatch object and append it to the block table record

Dim acHatch As Hatch = New Hatch()

acBlkTblRec.AppendEntity(acHatch)

acTrans.AddNewlyCreatedDBObject(acHatch,acObjIdColl)

'' Evaluate the hatch

acHatch.EvaluateHatch(True)

'' Increase the pattern scale by 2 and re-evaluate the hatch

acHatch.PatternScale = acHatch.PatternScale + 2

acHatch.SetHatchPattern(acHatch.PatternType,acHatch.PatternName)

acHatch.EvaluateHatch(True)

'' Save the new object to the database

acTrans.Commit()

End Using

End Sub

C#

using Autodesk.AutoCAD.Runtime;

using Autodesk.AutoCAD.ApplicationServices;

using Autodesk.AutoCAD.DatabaseServices;

using Autodesk.AutoCAD.Geometry;

[CommandMethod("EditHatchPatternScale")]

public static void EditHatchPatternScale()

{

// Get the current document and database

Document acDoc = Application.DocumentManager.MdiActiveDocument;

Database acCurDb = acDoc.Database;

// Start a transaction

using (Transaction acTrans = acCurDb.TransactionManager.StartTransaction())

{

// Open the Block table for read

BlockTable acBlkTbl;

acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId,

OpenMode.ForRead) as BlockTable;

// Open the Block table record Model space for write

BlockTableRecord acBlkTblRec;

acBlkTblRec = acTrans.GetObject(acBlkTbl[BlockTableRecord.ModelSpace],

OpenMode.ForWrite) as BlockTableRecord;

// Create a circle object for the boundary of the hatch

Circle acCirc = new Circle();

acCirc.Center = new Point3d(5,0);

acCirc.Radius = 3;

acBlkTblRec.AppendEntity(acCirc);

acTrans.AddNewlyCreatedDBObject(acCirc,true);

// Adds the circle to an object id collection

ObjectIdCollection acObjIdColl = new ObjectIdCollection();

acObjIdColl.Add(acCirc.ObjectId);

// Create the hatch object and append it to the block table record

Hatch acHatch = new Hatch();

acBlkTblRec.AppendEntity(acHatch);

acTrans.AddNewlyCreatedDBObject(acHatch,true);

// Set the properties of the hatch object设置填充对象属性

// Associative must be set after the hatch object is appended to the block table record and before AppendLoop

// 关联属性必须在将填充对象添加到块表记录之后、执行AppendLoop之前设置

acHatch.SetHatchPattern(HatchPatternType.PreDefined,acObjIdColl);

// Evaluate the hatch计算填充

acHatch.EvaluateHatch(true);

// Increase the pattern scale by 2 and re-evaluate the hatch填充图案的比例加2,重新计算填充

acHatch.PatternScale = acHatch.PatternScale + 2;

acHatch.SetHatchPattern(acHatch.PatternType,acHatch.PatternName);

acHatch.EvaluateHatch(true);

// Save the new object to the database保存到数据库

acTrans.Commit();

}

}

VBA/ActiveX Code Reference

Sub EditHatchPatternScale()

Dim hatchObj As AcadHatch

Dim patternName As String

Dim PatternType As Long

Dim bAssociativity As Boolean

' Define the hatch

patternName = "ANSI31"

PatternType = 0

bAssociativity = True

' Create the associative Hatch object

Set hatchObj = ThisDrawing.ModelSpace. _

AddHatch(PatternType,bAssociativity)

' Create the outer loop for the hatch.

Dim outerLoop(0 To 0) As AcadEntity

Dim center(0 To 2) As Double

Dim radius As Double

center(0) = 5

center(1) = 3

center(2) = 0

radius = 3

Set outerLoop(0) = ThisDrawing.ModelSpace. _

AddCircle(center,radius)

hatchObj.AppendOuterLoop (outerLoop)

hatchObj.Evaluate

' Change the scale of the hatch pattern by

' adding 2 to the current scale

hatchObj.patternScale = hatchObj.patternScale + 2

hatchObj.Evaluate

ThisDrawing.Regen True

End Sub

版权声明:本文内容由互联网用户自发贡献,该文观点与技术仅代表作者本人。本站仅提供信息存储空间服务,不拥有所有权,不承担相关法律责任。如发现本站有涉嫌侵权/违法违规的内容, 请发送邮件至 dio@foxmail.com 举报,一经查实,本站将立刻删除。

相关推荐


Format[$] ( expr [ , fmt ] ) format 返回变体型 format$ 强制返回为文本 -------------------------------- 数字类型的格式化 --------------------------------     固定格式参数:     General Number 普通数字,如可以用来去掉千位分隔号     format$("100,1
VB6或者ASP 格式化时间为 MM/dd/yyyy 格式,竟然没有好的办法, Format 或者FormatDateTime 竟然结果和系统设置的区域语言的日期和时间格式相关。意思是尽管你用诸如 Format(Now, "MM/dd/yyyy"),如果系统的设置格式区域语言的日期和时间格式分隔符是"-",那他还会显示为 MM-dd-yyyy     只有拼凑: <%response.write
在项目中添加如下代码:新建窗口来显示异常信息。 Namespace My ‘全局错误处理,新的解决方案直接添加本ApplicationEvents.vb 到工程即可 ‘添加后还需要一个From用来显示错误。如果到这步还不会则需要先打好基础啦 ‘======================================================== ‘以下事件
转了这一篇文章,原来一直想用C#做k3的插件开发,vb没有C#用的爽呀,这篇文章写与2011年,看来我以前没有认真去找这个方法呀。 https://blog.csdn.net/chzjxgd/article/details/6176325 金蝶K3 BOS的插件官方是用VB6编写的,如果  能用.Net下的语言工具开发BOS插件是一件很愉快的事情,其中缘由不言而喻,而本文则是个人首创,实现在了用V
Sub 分列() ‘以空格为分隔符,连续空格只算1个。对所选中的单元格进行处理 Dim m As Range, tmpStr As String, s As String Dim x As Integer, y As Integer, subStr As String If MsgBox("确定要分列处理吗?请确定分列的数据会覆盖它后面的单元格!", _
  窗体代码 1 Private Sub Text1_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single) 2 Dim path As String, hash As String 3 For Each fil
  Imports MySql.Data.MySqlClient Public Class Form1 ‘ GLOBAL DECLARATIONS Dim conString As String = "Server=localhost;Database=net2;Uid=root;Pwd=123456;" Dim con As New MySqlConnection
‘導入命名空間 Imports ADODB Imports Microsoft.Office.Interop   Private Sub A1() Dim Sql As String Dim Cnn As New ADODB.Connection Dim Rs As New ADODB.Recordset Dim S As String   S = "Provider=OraOLEDB.Oracl
Imports System.IO Imports System.Threading Imports System.Diagnostics Public Class Form1 Dim A(254) As String    Function ping(ByVal IP As Integer) As String Dim IPAddress As String IPAddress = "10.0.
VB运行EXE程序,并等待其运行结束 参考:https://blog.csdn.net/useway/article/details/5494084 Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long Pr
今天碰到一个问题,登陆的时候,如果不需要验证手机号为空,则不去验证手机号 因为登陆的时候所有的验证信息都存放在一个数组里 Dim CheckUserInfo() As String ={UserBirthday, SecEmail, UserMob, UserSex, RealNameFirst, RealName, CheckCardID, CheckCardType, Contactemail
在VB6.0中,数据访问接口有三种: 1、ActiveX数据对象(ADO) 2、远程数据对象(RDO) 3、数据访问对象(DAO) 1.使用ADO(ActiveX Data Objec,ActiveX数据对象)连接SQL Server 1)使用ADO控件连接 使用ADO控件的ConnectionString属性就可以连接SQL Server,该属性包含一个由分号分隔的argument=value语
注:大家如果没有VB6.0的安装文件,可自行百度一下下载,一般文件大小在200M左右的均为完整版的软件,可以使用。   特别提示:安装此软件的时候最好退出360杀毒软件(包括360安全卫士,电脑管家等,如果电脑上有这些软件的话),因为现如今的360杀毒软件直接会对VB6.0软件误报,这样的话就可能会在安装过程中被误报阻止而导致安装失败,或者是安装后缺乏很多必须的组件(其它的杀毒软件或安全卫士之类的
Private Sub Form_Load() Call conndb End Sub Private Function conndb() Dim cn As New ADODB.Connection Dim rs As New ADODB.Recordset Dim strCn, sql As String Dim db_host As String Dim db_user As String
  PPSM06S70:  Add  moddate  EDITSPRINTJOB:  MAX(TO_CHAR(ETRN.MODDATE, ‘yyyy/mm/dd/HH24:MI AM‘)) ACTUAL_SHIPDATE   4.Test Scenario (1) :Query SQL Test DN:8016578337 SELECT CTRN.TKCTID TRUCK_ID,        
  沒有出現CrystalReportViewer時,須安裝CRforVS_13_0. 新增1個數據集,新增1個數據表,添加二列,列名要和資料庫名一樣. 修改目標Framework 修改app.config, <startup >改成<startup useLegacyV2RuntimeActivationPolicy ="true">  CrystalReport1.rpt增加數據庫專家 在表單
Imports System.Threading Imports System Public Class Form1 Dim th1, th2 As Thread Public Sub Method1() Dim i As Integer For i = 1 To 100 If Me.Label1.BackColor =
Friend Const PROCESS_ALL_ACCESS = &H1F0FFF = 2035711 Friend Const PROCESS_VM_READ = &H10 Friend Const PROCESS_VM_WRITE = &H20 Friend Const PAGE_READONLY = &H2 Friend Const PAGE_READWRITE = &H4 Friend
以下代码随手写的 并没有大量测试 效率也有待提升 如果需要C#的请自行转换 Function SplitBytes(Data As Byte(), Delimiter As Byte()) As List(Of Byte()) Dim i = 0 Dim List As New List(Of Byte()) Dim bytes As New
Imports System.Data.SqlClient Public Class Form1 REM Public conn1 As SqlConnection = New SqlConnection("server=.; Integrated Security=False;Initial Catalog= mydatabase1; User ID= sa;password")